##Create Poisson data set
require(msm)
##model:

y_mon <- y_len <-  psi_n <- vector(mode="numeric", length=75)
xi_b <- xi_m <- beta <- mu <- vector(mode="numeric", length=75)

beta_gr <- c(-0.1, -0.2, -0.15, -0.08, -0.18, -0.20)
gr <- rep(seq(1:6), 13)
mu_0 <- 0.15
mu_1 <- 0.05

for (i in 1:75){
  ##months before treatment
  y_mon[i] <- round(rtnorm(1, mean=7, sd=9, lower=0, upper=40), digits=0)
  y_len[i] <- round(rtnorm(1, 44, 11, lower=0, upper=50), digits=0)
  psi_n[i] <- round(rtnorm(1, 0.12, 0.2, lower=-.99, upper=.99),4)
  xi_b[i] <- rnorm(1, 0, 0.06)
  xi_m[i] <- rtnorm(1, 0, 1.27, lower=-2, upper=2)
  beta[i] <- min(-0.02,beta_gr[gr[i]]+xi_b[i])
  mu[i] <- mu_0 + y_mon[i]*mu_1+xi_m[i]
}

Y <- eps <- delta <- matrix(nrow=75, ncol=50)
for (n in 1:75){
  eps[n,1] <- rnorm(1,0,0.1)
  delta[n,1] <- eps[n,1]
    for (t in 2:y_len[n]){
    eps[n,t] <- rnorm(1,0,0.1)
    delta[n,t] <- delta[n, t-1]+beta[n]+eps[n,t-1]*psi_n[n]+eps[n,t]
    }
    for (t in 1:y_len[n]){
    Y[n,t] <- rpois(1, exp(mu[n]+delta[n,t]))
    }
}

##interaction effect
y_int <- as.factor(gr[1:75])

dummy <- model.matrix(~y_int)
dummy <- dummy[,2:6]

y_obs <- Y
y_obs[is.na(y_obs)] <- 99

 
data = list(y_obs=y_obs, T=50, N=75, y_mon=y_mon, y_len=y_len, ntot=sum(y_len), d=dummy)
